\begin{code}
module PIL where
import Prelude hiding (abs)

infixl 7 `up`, `dn`
infixl 7 //
\end{code}

For the moment, compute over the integers.

\begin{code}
type Coord = Integer
\end{code}

\begin{code}
up, dn :: Coord -> Coord -> Coord
up = max
dn = min
-- abs x = x `up` (-x)
\end{code}

There are two versions of the 'sign' function: sign, which returns '1'
for '0' (to be used when the sign of 0 can be arbitrary) and sgn,
which takes a subsidiary boolean expression to be evaluated if the
argument is 0.

\begin{code}
sign x | x >= 0    = 1
       | otherwise = -1

sgn x b | x > 0     = 1
	| x < 0     = -1
	| b         = 1
        | otherwise = -1
\end{code}

\begin{code}
(//), safeDiv :: Coord -> Coord -> Coord
safeDiv a b = case a `quotRem` b of
	        (q, 0) -> q
		_      -> error "safeDiv: parity"
(//) = safeDiv
\end{code}

Copyright 2002, 2004 Dylan Thurston.

This file is part of the genus2fiber program for computing what
percentage of tunnel-number one 3-manifolds fiber.  It can be
redistributed and/or modified under the terms of the GNU General
Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.
